<template>
  <div class="custom-select-dropdown">
    <b-dropdown ref="cDropdown" text="" variant="link" no-caret class="w-100" :disabled="disabled">
      <template #button-content>
        
        <span class="ml-50 text-body float-left font-400" v-if="multiple">
          <span v-if="checkedAllBox" class="selected-value">All {{ title }}</span>
          <span v-if="!checkedAllBox && selectedItemTitle != ''" class="selected-value">{{
            selectedItemTitle
          }}</span>
          <span v-if="!checkedAllBox && selectedItemTitle == ''"  class="text-placeholder">Select {{ selectTitle }}</span>
        </span>
        <span class="ml-50 text-body float-left font-400" v-if="!multiple">
          <span v-if="selectedValue != ''" class="selected-value">{{ selectedValueText() }}</span>
          <span v-if="selectedValue == ''"  class="text-placeholder">Select {{ selectTitle }}</span>
        </span>
        <b-img :src="downArrowIcon" class="text-body float-right" />
      </template>
      <b-dropdown-form>
        <div class="form-card" v-if="searchBar">
          <b-form-input v-model="searchItems" value="" @input="searchItemFromList($event)" placeholder="Search"
            type="text" class="d-inline-block custom-search-box" />
          <hr />
        </div>

        <div class="form-card" v-if="selectAll">
          <b-form-checkbox v-model="checkedAllBox" :name="'custom-checkall-checkbox-main-' + selectTitle"
            class="checkall w-100 m-0" @change="checkAll($event)" inline v-if="isCheckbox"
            :disabled="checkItemDisabled('all')">
            All {{ title }}
          </b-form-checkbox>
          <p v-if="!isCheckbox" class="select-option"
            :class="selectedValue == 'All' + (title ? ' ' + title : '') ? 'active' : ''"
            @click="filterApply('All' + (title ? ' ' + title : ''), true)">
            All {{ title }}
          </p>
          <hr />
        </div>
        <template v-if="!isSearch && options.length == 0">
          <p class="select-option">
            No Data to Select
          </p>
        </template>
        <template v-if="!isSearch && options.length > 0" v-for="option in options">
          <b-form-checkbox v-model="checkedItems" :name="'custom-checkall-checkbox-' + selectTitle" :checked="true"
            :value="option.id" @change="checkRow()" inline v-if="isCheckbox" :disabled="checkItemDisabled(option.id)">
            {{ option.name }}
          </b-form-checkbox>
          <p v-if="!isCheckbox" class="select-option" :class="selectedValue == option.name || selectedValue == option.id ? 'active' : ''
            " @click="filterApply(option, true)">
            {{ option.name }}

            <span v-if="option.sidebarColor" class="sidebar-fill"
              :style="{ 'background-color': option.sidebarColor }"></span>
          </p>
        </template>
        <template v-if="isSearch && optionsList.length == 0">
          <p class="select-option">
            No Data to Select
          </p>
        </template>
        <template v-if="isSearch" v-for="option in optionsList">
          <b-form-checkbox v-model="checkedItems" :name="'custom-checkall-checkbox-'.selectTitle" :checked="true"
            :value="option.id" @change="checkRow()" inline v-if="isCheckbox" :disabled="checkItemDisabled(option.id)">
            {{ option.name }}
          </b-form-checkbox>

          <p v-if="!isCheckbox" class="select-option" :class="selectedValue == option.name || selectedValue == option.id ? 'active' : ''
            " @click="filterApply(option, true)">
            {{ option.name }}
            <span v-if="option.sidebarColor" class="sidebar-fill"
              :style="{ 'background-color': option.sidebarColor }"></span>
          </p>
        </template>
      </b-dropdown-form>

      <div v-if="filterButton">
        <hr />
        <div class="dropdown-btn-footer">
          <b-button class="btn-select-apply" variant="primary" type="submit" @click="filterApply('', true, true)">
            {{ filterButtonTitle }}
          </b-button>
        </div>
      </div>
    </b-dropdown>
  </div>
</template>

<script>
import {
  BButton,
  BFormGroup,
  BFormInput,
  BFormCheckboxGroup,
  BFormCheckbox,
  BImg,
  BCol,
  BRow,
  BCard,
  BDropdown,
  BDropdownItem,
  BDropdownForm,
} from "bootstrap-vue";
export default {
  components: {
    BCard,
    BButton,
    BCol,
    BRow,
    BImg,
    BFormInput,
    BFormCheckbox,
    BFormGroup,
    BFormCheckboxGroup,
    BDropdown,
    BDropdownItem,
    BDropdownForm,
  },
  props: {
    title: {
      type: String,
      require: false,
      default: "",
    },
    selectTitle: {
      type: String,
      require: false,
      default: "",
    },
    checkboxName: {
      type: String,
      require: false,
      default: "",
    },
    options: {
      type: Array,
      require: true,
    },
    selectedItemsArr: {
      type: Array,
      require: false,
      default: () => [],
    },
    searchBar: {
      type: Boolean,
      default: false,
    },
    isAllChecked: {
      type: Boolean,
      default: false,
    },
    selectAll: {
      type: Boolean,
      default: false,
    },
    filterButton: {
      type: Boolean,
      default: false,
    },
    multiple: {
      type: Boolean,
      default: true,
    },
    isCheckbox: {
      type: Boolean,
      default: true,
    },
    filterButtonTitle: {
      type: String,
      default: "Apply",
    },
    selectedValue: {},
    disabled: {
      default: false,
    },
    itemDisabled: {
      default: false,
    }
  },
  watch: {
    selectedValue: function (newVal, oldVal) {
      console.log(newVal);
      console.log(oldVal);
      this.selectedValueText();
    },
    selectedItemsArr: function (newVal, oldVal) {
      this.checkedItems = newVal;
      if (this.options.length == this.checkedItems.length) {
        this.checkedAllBox = true;
      }
      this.changeTitle();
    },
    isAllChecked: function (newVal, oldVal) {
      this.checkedAllBox = newVal;
      this.changeTitle();
    },
  },
  mounted() {
    console.log('It is loaded')
    this.changeTitle();
    if (this.isAllChecked) {
      document
        .querySelectorAll(
          "input[type='checkbox'][name='custom-checkall-checkbox-" +
          this.selectTitle +
          "']"
        )
        .forEach((chk, index) => {
          this.checkedItems.push(chk.value);
        });
      this.selectedItems = this.options;
      this.filterApply();
    } else {
      this.checkedItems = this.selectedItemsArr;
    }


  },
  data() {
    return {
      downArrowIcon: new URL("/src/assets/images/icons/down-arrow.svg", import.meta.url).href,
      selectedItems: [],
      optionsList: [],
      checkedItems: this.selectedItemsArr,
      checkedAllBox: this.isAllChecked,
      searchItems: "",
      selectedItemTitle: "",
      isSearch: false,
    };
  },
  methods: {
    checkItemDisabled(id) {
      if (this.itemDisabled == true) {
        if (this.checkedItems.includes(id)) {
          return false;
        } else {
          return true;
        }
      } else {
        return false;
      }
    },
    searchItemFromList(e) {
      this.isSearch = false;
      this.optionsList = this.options;
      if (e != "") {
        this.isSearch = true;
        var search = new RegExp(e, "i"); // prepare a regex object
        this.optionsList = this.options.filter((item) => search.test(item.name));
      }
    },
    checkAll(event) {
      this.checkedItems = [];
      this.selectedItems = [];
      this.checkedAllBox = false;
      if (event) {
        document
          .querySelectorAll(
            "input[type='checkbox'][name='custom-checkall-checkbox-" +
            this.selectTitle +
            "']"
          )
          .forEach((chk, index) => {
            this.checkedItems.push(chk.value);
          });
        this.selectedItems = this.options;
        this.checkedAllBox = true;
      }
      this.changeTitle();
      if (this.filterButton == false) {
        let hide = false;
        // if (this.checkedAllBox == true) {
        //   hide = true;
        // }
        this.filterApply();
      }
    },
    checkRow() {
      if (this.checkedItems.length == this.options.length) {
        this.checkedAllBox = true;
      } else {
        this.checkedAllBox = false;
      }
      this.changeTitle();

      if (this.filterButton == false) {
        this.filterApply();
      }
    },
    changeTitle() {
      this.selectedItems = [];
      if (this.checkedItems.length > 0) {
        this.checkedItems.forEach((element) => {
          this.options.forEach((elem) => {
            if (elem.id == element) {
              this.selectedItems.push(elem);
            }
          });
        });
      }
      if (this.selectedItems.length > 0) {
        if (this.selectedItems.length > 1) {
          this.selectedItemTitle =
            this.selectedItems[0].name +
            " & " +
            (this.selectedItems.length - 1) +
            " More";
        } else {
          this.selectedItemTitle = this.selectedItems[0].name;
        }
      } else {
        this.selectedItemTitle = "";
      }
    },
    selectedValueText() {
      let title = this.selectedValue;
      console.log(this.options);
      this.options.forEach((opt, index) => {
        if (opt.id == this.selectedValue) {
          title = opt.name;
        }
      });
      return title;
    },
    filterApply(value = "", hide = false, searchClear = false) {
      if (searchClear == true) {
        this.searchItems = "";
        this.isSearch = false;
        this.optionsList = this.options;
      }

      if (this.isCheckbox) {
        let data = {
          selectedItems: this.selectedItems,
          checkedAllBox: this.checkedAllBox,
          checkboxName: this.checkboxName
        };
        this.$emit("filterButtonAction", data);
      } else {
        this.$emit("filterButtonAction", value);
      }

      if (hide) {
        this.$refs.cDropdown.hide();
      }
    },
  },
};
</script>
